;;;	      Structure and Interpretation of Computer Programs
;;;			       Second Edition 
;;;                          Sample Problem Set 
;;;
;;;			    Code file WORLD.SCM
;;;  This file contains the outermost driver and the person definitions

;;;============================================================================
;;; You can extend this file to make more stuff part of your world.
;;;============================================================================

;;;============================================================================
;;; *CAVEAT* To keep your world consistent, whenever you change a procedure or 
;;;          redefine a person/place/etc you should reload this entire file    
;;;          into Scheme. This prevents you from having old-moldy folks running
;;;          around who have not evolved to adhere to your modifications. To   
;;;          make this work out well, you should create little scripts at the  
;;;          end of this file to make the game evolve as you work through it.  
;;;          [See the bottom of this file for an example.]                     
;;;============================================================================

(load "game.scm")              ;; Underlying engine
(load "places.scm")            ;; Geography now in its own file
(load "commands.scm")          ;; Implementation of player commands
(initialize-clock-list)

;; The important critters in our world...
;;---------------------------------------

;; named-objects now have short-desc in constructor
;; optional long-desc added with 'add-long-desc message

(define errol   (make&install-person "Errol" '(Errol) "Professor Errol" errol-office 3 'male 43))
(ask errol 'add-long-desc "Nondescript
   Errol is wearing:
      torso:             standard-issue shirt
      legs:              standard-issue pants
      feet:              standard-issue boots")

(define terry   (make&install-person "Terry" '(Terry) "Professor Terry" terry-office 2 'male 46))
(ask terry 'add-long-desc "Nondescript
   Terry is wearing:
      torso:             standard-issue shirt
      legs:              standard-issue pants
      feet:              standard-issue boots")

(define grendel (make&install-troll "Grendel" '(Grendel) "Grendel the troll" dungeon 4 86))
(ask grendel 'add-long-desc "A muscular eight foot troll. It looks hungry.
   Grendel is wearing:
      wielded:           crude club
      body:              smelly rags")

;; defines shouldn't be nessecary any more, but I'll leave them for now
(define terry-card
  (make&install-sd-card '(terry-card) "terry-card" terry-office '888-12-3456))
(define errol-card
  (make&install-sd-card '(errol-card) "errol-card" errol-office '888-98-7654))
(define cube1
  (make&install-thing '(large blue cube) "large blue cube" errol-office))
(ask cube1 'add-long-desc "It's a large blue cube with no other remarkable features.")
(define cube2
  (make&install-thing '(small green cube) "small green cube" errol-office))
(ask cube2 'add-long-desc "It's a small green cube with no other remarkable features.")
(define sphere1
  (make&install-thing '(large green sphere) "large green sphere" errol-office))
(ask sphere1 'add-long-desc "It's a large green sphere with no other remarkable features.")
(define sphere2
  (make&install-thing '(small blue sphere) "small blue sphere" errol-office))
(ask sphere2 'add-long-desc "It's a small blue sphere with no other remarkable features.")

;;------------------------------------------------
;; Scripted and temporary things

(define (play-game)
  (display-message '("Here we go!!"))
  ((lookup-command 'look) '() )
  (run-game)
  )

;; This is a simplified version of one of my characters from when I used to play MUDs a few years ago...
;;   ...this whole program has reminded me of a MUD since I first saw it (add simultaneous multiplay and
;;   statistics and skills and equipment and monsters and it IS a simple MUD).
;; Anyway, the description is pretty much accurate, except that on the MUD the class didn't need
;;   explaining, and behaviors and such were supposed to be role-played. And I don't remember if there
;;   really was a firey aura spell, but there should have been if there wasn't.

(define lefire (make&install-person "Lefire" '(Lefire) "Elementalist Lefire" smithlobby 0 'female 142))
(ask lefire 'add-long-desc "The elementalist is a class of warrior mage from a distant land (i.e., the 'Towers' MUD, probably defunct now) who manipulates the forces of the four elements. The elementalist's mackigs are mostly of the 'miscellaneous' variety, such as levitating and summoning food, but include some elemental multi-strike attacks. Combined with a decent fighting ability, this makes the elementalist a good 'loner' class, though not as powerful overall as the less versatile classes. As with any class, specialization within the class is, of course, possible, and can contribute to role-playing as well.
   Lefire has lost her powers here due to a mysterious condition known as 'lack of necessary code', but remains aloof and carries herself confidently. As suggested by her fiery red hair and eyes, she shuns the study of the 'water' element in favor of dedicating her efforts to mastering the 'fire' element.
   Lefire is wearing:
      wielded:          gnarled staff  <magical>
      body:             mystic cloak  <magical>
      feet:             travelling shoes  <magical>
      floating nearby:  orb of light  <glowing>")

(define player lefire)
(play-game)